<template>
    <div class="examination">
     <el-dialog @close="closeDialog" :visible.sync="dialogTableVisible" width="70%">
        <div slot="title" class="titleBox">
        <i :class="tableType === 0? 'el-icon-document':'el-icon-edit-outline'" style="font-size: 20px"></i>
        <!-- <img style="width: 25px; height: 25px" src='../../../../assets/img/imgScreen/more.png' /> -->
        <span style="margin-left:10px;font-size:18px">{{tableTypeDsc}}</span>
        </div>
       <el-form ref="baseData" label-width="80px" :rules="ruleValidate" :model="baseData">
         <el-row>
          <el-col :span="8">
            <el-form-item prop="ruleName" label="规则名称">
              <el-input v-model="baseData.ruleName" size="small"></el-input>
            </el-form-item>
          </el-col>
          <el-col :span="8">
            <el-form-item prop="ruleTypeName" label="规则类型">
              <el-select v-model="ruleTypeNameTypeIndex" filterable collapse-tags size="small">
                <el-option v-for="(item,index) in ruleTypeNameType" :key="index" :label="item.baseName" :value="index">
                </el-option>
              </el-select>
            </el-form-item>
          </el-col>
          <el-col :span="8">
            <el-form-item prop="ruleVer" label="规则版本号">
              <el-input v-model="baseData.ruleVer" size="small"></el-input>
            </el-form-item>
          </el-col>
         </el-row>
          <el-row>
          <el-col :span="24">
            <el-form-item prop="callApi" label="调用API">
              <el-input v-model="baseData.callApi" size="small"></el-input>
            </el-form-item>
          </el-col>
          <el-col :span="24">
            <el-form-item prop="memo" label="备注">
              <el-input v-model="baseData.memo" size="small"></el-input>
            </el-form-item>
          </el-col>
         </el-row>
       </el-form>
       <span slot="footer" class="dialog-footer">
        <el-button type="goon" size="mini" icon="el-icon-check" @click="tableType === 0 ? addData():modifyData()">确定</el-button>
        <el-button size="mini" type="goon" icon="el-icon-remove-outline" @click="cancel">取消</el-button>
      </span>
    </el-dialog>
    </div>
</template>
<script>
import {
  getCookie
} from '@/utils/util.js';
import {
  cookieUserId,
  cookieUserName
} from '@/config/config.js';
let userName = getCookie(cookieUserName);
let userId = getCookie(cookieUserId);
export default {
  props: ['showFlag', 'Params'],
    data () {
        return {
            dialogTableVisible: false,
            tableTypeDsc: '新增业务规则',
            tableType: 0,
            seen: true,
            seenNo: true,
            beInvalid: false,
            ruleTypeNameTypeIndex: 0,
            ruleTypeNameType: [],
            tableData: [],
            baseData: {
              ruleNo: '',
              ruleName: '',
              callApi: '',
              ruleVer: '',
              memo: ''
            },
            ruleValidate: {
              //ruleTypeName: [{ required: true, message: '该项不能为空', trigger: 'change' }],
              ruleName: [{ required: true, message: '该项不能为空', trigger: 'change' }],
              // merchAtrrName: [{ required: true, message: '该项不能为空', trigger: 'change' }]
             }
        }
    },
    mounted () {
      this.getruleTypeNameType ()
    },
    methods: {
      cancel () {
        let _this = this;
        _this.tableData = [];
        _this.ruleTypeNameTypeIndex = 0,
        _this.merchAtrrNameTypeIndex = 0,
        _this.baseData = {
              ruleNo: '',
              ruleName: '',
              callApi: '',
              ruleVer: '',
              memo: ''
        }
        _this.dialogTableVisible = false
        _this.$emit('refresh')
      },
      addData () {
        let _this = this;
         _this.tableData = [];
         _this.$refs['baseData'].validate((valid) => {
          if (valid) {
             _this.baseData.createMan = userName;
             _this.baseData.createNo = userId;
             _this.baseData.ruleTypeCode = _this.ruleTypeNameType[_this.ruleTypeNameTypeIndex].baseCode;
             _this.baseData.ruleTypeName = _this.ruleTypeNameType[_this.ruleTypeNameTypeIndex].baseName;
             _this.tableData.push(_this.baseData)
             _this.axios.post('pass/baseManagement/v1/limsbaserules/', _this.tableData, {individualType: 'json'}).then(res => {
                if (res.succeed) {
                  _this.dialogTableVisible = false;
                 this.$message.success('添加成功')
                 _this.$emit('refresh')
                } else {
                 this.$message.error(res.message)
                }
                }).catch(e => {
                 this.$message.error(e.message)
               })
         }
       })
      },
      modifyData () {
        let _this = this;
        _this.tableData = [];
        _this.$refs['baseData'].validate((valid) => {
        if (valid) {
        _this.dialogTableVisible = false;
        _this.baseData.updateMan = userName;
        _this.baseData.updateNo = userId;
        _this.baseData.ruleTypeCode = _this.ruleTypeNameType[_this.ruleTypeNameTypeIndex].baseCode;
        _this.baseData.ruleTypeName = _this.ruleTypeNameType[_this.ruleTypeNameTypeIndex].baseName;
        _this.tableData.push(_this.baseData)
        _this.axios.put('pass/baseManagement/v1/limsbaserules/', _this.baseData, {individualType: 'json'}).then(res => {
           if (res.succeed) {
            this.$message.success('修改成功')
            _this.$emit('refresh')
           } else {
            this.$message.error(res.message)
           }
           }).catch(e => {
            this.$message.error(e.message)
          })
        }
        })
      },
     closeDialog () {
       let _this = this;
       _this.tableData = [];
       _this.baseData = {
              ruleNo: '',
              ruleName: '',
              callApi: '',
              ruleVer: '',
              memo: ''
        }
       _this.seen = true;
       _this.seenNo = true;
       _this.beInvalid = false;
       _this.$emit('refresh')
     },
      getruleTypeNameType () {
        this.axios.post("pass/baseManagement/v1/limsbaseinfos/queryBaseInfoByBaseCode",{validFlag:1,baseCode:4838}, {individualType: 'json'}).then(res => {
              this.ruleTypeNameType = res.data
            }).catch(e => {
              // this.dataLoading = false;
            });
     }
    },
    watch: {
      showFlag (arg) {
        let _this = this;
        _this.dialogTableVisible = true;
        if (_this.Params !== null) {
          _this.baseData = Object.assign({},this.Params);
          _this.tableType = 1;
          _this.tableTypeDsc = '修改业务规则';
          _this.seen = false;
          _this.beInvalid = true;
          for (let j = 0; j < _this.ruleTypeNameType.length; j++) {
          if (_this.ruleTypeNameType[j].baseName === _this.baseData.ruleTypeName) {
             _this.ruleTypeNameTypeIndex = j;
          }
          }
        } else {
          _this.tableType = 0;
          _this.seenNo = false;
          _this.tableTypeDsc = '新增业务规则';
        }
      }
    }
}
</script>
<style lang="less">
.customWidth_syst{
  width: 600px !important
}
</style>